#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_security.interfaces import ISecurityManager
from pyams_skin.layer import IPyAMSLayer

# import packages
from pyams_utils.registry import query_utility
from pyramid.view import view_config


@view_config(name='find-principals.json', request_type=IPyAMSLayer,
             permission='system.view', renderer='json', xhr=True)
def find_principals(request):
    """Find all principals matching given query"""
    query = request.params.get('query')
    if not query:
        return []
    manager = query_utility(ISecurityManager)
    return [{'id': principal.id,
             'text': principal.title} for principal in manager.find_principals(query)]
